
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>dropwizard metrics  - healthchecks / 憋错料</title>

    <meta name="description" content="dropwizard metrics  - healthchecks 系统监控一直都是很重要的内容,可以让应用主动通知你系统现在的允许状况.Java世界里面dropwizard提供了系统监控的功能,个人觉得非常好用,主要分为2大块,一块是系统健康监控,一块是系统的运行度量统计.第一篇先介绍健康依赖. 首先在pom文件中加入metrics健康监控包依赖. &lt;!-- metrics start --&gt; &lt;dependency&gt; &lt;groupId&gt;io.dropwizard.metrics&lt;/groupId&gt; &lt;ar ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">dropwizard metrics  - healthchecks</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>系统监控一直都是很重要的内容，可以让应用主动通知你系统现在的允许状况。Java世界里面dropwizard提供了系统监控的功能，个人觉得非常好用，主要分为2大块，一块是系统健康监控，一块是系统的运行度量统计。第一篇先介绍健康依赖。</p>
<p>首先在pom文件中加入metrics健康监控包依赖。</p>
<pre><code>        &lt;!-- metrics start --&gt;
        &lt;dependency&gt;
            &lt;groupId&gt;io.dropwizard.metrics&lt;/groupId&gt;
            &lt;artifactId&gt;metrics-core&lt;/artifactId&gt;
            &lt;version&gt;${project-metricsVersion}&lt;/version&gt;
        &lt;/dependency&gt;
        &lt;dependency&gt;
            &lt;groupId&gt;io.dropwizard.metrics&lt;/groupId&gt;
            &lt;artifactId&gt;metrics-healthchecks&lt;/artifactId&gt;
            &lt;version&gt;${project-metricsVersion}&lt;/version&gt;
        &lt;/dependency&gt;
        &lt;!-- metrics end --&gt;</code></pre>
<p>其次创建健康检查的Scheduled task服务，通过scheduled task把健康信息发送到监控平台，也可以简单记录文件，连续几次不健康后邮件短信通知，现在展示一种简单实现（通过Logger单纯记录健康状态到文件）：</p>
<pre><code>/**
 *
 */
package com.cloud.demo.service.impl;

import java.util.Map;
import java.util.Map.Entry;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.codahale.metrics.health.HealthCheck;
import com.codahale.metrics.health.HealthCheck.Result;
import com.codahale.metrics.health.HealthCheckRegistry;

/**
 * @author cloudlu
 *
 */
public class SystemHealthCheck implements Runnable{

    private static final Logger LOG = LoggerFactory.getLogger(SystemHealthCheck.class);

    private final static HealthCheckRegistry healthChecks = new HealthCheckRegistry();

    public static boolean registerToSysHealthCheck(final String name, final HealthCheck healthCheck){
        if(healthChecks.getNames().contains(name)){
            return false;
        }
        healthChecks.register(name, healthCheck);
        return true;
    }

    public void run(){
        final Map&lt;String, Result&gt; results = healthChecks.runHealthChecks();
        StringBuilder message = null;
        for (Entry&lt;String, Result&gt; entry : results.entrySet()) {
            message = new StringBuilder(entry.getKey());
            if (entry.getValue().isHealthy()) {
                message.append(" is healthy: ").append(entry.getValue().getMessage());
                LOG.info(message.toString());
            } else {
                message.append(" is UNHEALTHY: ").append(entry.getValue().getMessage());
                LOG.error(message.toString(), entry.getValue().getError());
            }
        }
    }
}</code></pre>
<p>最后把要监控的系统注册到健康服务，并且提供指定回调函数，显示系统状态，例如查看hibernate的sessionfactory状态如下：</p>
<pre><code>/**
 *
 */
package com.cloud.demo.service.impl;

import javax.annotation.Resource;

import org.hibernate.SessionFactory;
import org.springframework.orm.jpa.vendor.Database;

import com.codahale.metrics.health.HealthCheck;

/**
 * @author cloudlu
 *
 */
public class DatabaseHealthCheck extends HealthCheck {

    private final static String HEALTHCHECKNAME = DatabaseHealthCheck.class.getSimpleName();

    private SessionFactory sessionFactory;

    public DatabaseHealthCheck(SessionFactory sessionFactory) {
        this.sessionFactory = sessionFactory;
    }

    public DatabaseHealthCheck(){
        SystemHealthCheck.registerToSysHealthCheck(HEALTHCHECKNAME, this);
    }

    @Override
    public HealthCheck.Result check() throws Exception {
        if (!sessionFactory.isClosed()) {
            return HealthCheck.Result.healthy();
        } else {
            return HealthCheck.Result.unhealthy("sessionFactory is closed " + sessionFactory.getStatistics());
        }
    }

}</code></pre>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-29 04:02:19 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/java/" title="java">java</a>, <a href="https://www.biecuoliao.com/tag/metrics/" title="metrics">metrics</a>, <a href="https://www.biecuoliao.com/tag/dropwizard/" title="dropwizard">dropwizard</a>, <a href="https://www.biecuoliao.com/tag/healthchk/" title="healthchk">healthchk</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>dropwizard metrics  - healthchecks的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0lXgNW0.html" rel="bookmark">dropwizard metrics  - 基本使用介绍</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				之前在healthcheck中介绍了怎样通过metrics lib往系统中增加一些简单的健康侦測.如今讲讲dropwizard metrics更重要的部分.记录系统的度量信息. dropwizard提供了多种度量方式:最简单记数counter,复杂点的实用于计算时间分布的histogram,用于计算速率的meter,以及同一时候有histogram和meter功能的timer.有兴趣能够去看看实现细节,类非常少,非常easy读懂. Metrics的报告方式和healthcheck非常相似.库自生			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3ODoQ74.html" rel="bookmark">metrics&sol;度量</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				新blog地址:http://hengyunabc.github.io/about-metrics/ 想要实现的功能 应用可以用少量的代码,实现统计某类数据的功能 统计的数据可以很方便地展示 metrics metrics,按字面意思是度量,指标. 举具体的例子来说,一个web服务器: - 一分钟内请求多少次? - 平均请求耗时多长? - 最长请求时间? - 某个方法的被调用次数,时长? 以缓存为例: - 平均查询缓存时间? - 缓存获取不命中的次数/比例? 以jvm为例: - GC的次数? -			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0kK57l0.html" rel="bookmark">Java程序监控---Metrics</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				概念 Metrics是一个给JAVA服务的各项指标提供度量工具的包,在JAVA代码中嵌入Metrics代码,可以方便的对业务代码的各个指标进行监控 目前最为流行的 metrics 库是来自 Coda Hale 的 dropwizard/metrics,该库被广泛地应用于各个知名的开源项目中.例如 Hadoop,Kafka,Spark,JStorm 中. 有一些优点: 提供了对Ehcache.Apache HttpClient.JDBI.Jersey.Jetty.Log4J.Logback.JVM			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MgNZPn4.html" rel="bookmark">JAVA Metrics 度量工具使用介绍1</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Java Metric使用介绍1 Metrics是一个给JAVA提供度量工具的包,在JAVA代码中嵌入Metrics代码,可以方便的对业务代码的各个指标进行监控,同一时候,Metrics可以非常好的跟Ganlia.Graphite结合,方便的提供图形化接口. 以下简介下Metrics怎样使用. Maven地址: 仅仅须要添加metrics-core就可以使用 &lt;dependency&gt; &lt;groupId&gt;com.yammer.metrics&lt;/groupId&gt; &lt;a			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MGR9N64.html" rel="bookmark">第三十六章 metrics（4）- metrics-graphite</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				将metrics report给graphite(carbon-relay) 一.代码 1.pom.xml 1 &lt;!-- metrics-graphite --&gt; 2 &lt;dependency&gt; 3 &lt;groupId&gt;io.dropwizard.metrics&lt;/groupId&gt; 4 &lt;artifactId&gt;metrics-graphite&lt;/artifactId&gt; 5 &lt;/dependency&gt; 依托于springboot			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MVWQBj0.html" rel="bookmark">Dropwizard与Spring Boot比较</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在这篇文章中我们将讨论的Java轻量级框架Dropwizard和Spring Boot的相似性和差异. 首先,这是一个选择自由和速度需要,无论你在Dropwizard和Spring Boot选择哪个,这两个框架自身都显得有点固执己见,他们都坚信约定优于配置,那么是如何固执呢?你会发现,在我们进行比较以后,它们每个都混入了第三方库包,大部分并不是核心功能需要而是出于集成需要.这种牺牲的好处是获得好的性能.下面图中使用白色显示依赖包. Spring的依赖 Spring Boot聚焦于Spring应用			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MPOwpm4.html" rel="bookmark">SOA专题---Dropwizard与Spring Boot比较</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在这篇文章中我们将讨论的Java轻量级框架Dropwizard和Spring Boot的相似性和差异. 首先,这是一个选择自由和速度需要,无论你在Dropwizard和Spring Boot选择哪个,这两个框架自身都显得有点固执己见,他们都坚信约定优于配置,那么是如何固执呢?你会发现,在我们进行比较以后,它们每个都混入了第三方库包,大部分并不是核心功能需要而是出于集成需要.这种牺牲的好处是获得好的性能.下面图中使用白色显示依赖包. Spring的依赖 Spring Boot聚焦于Spring应用			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0dYWOn3.html" rel="bookmark">Java Metrics</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Java Metrics Java Metrics是一个功能比较强大的java统计库,它的输出组件也很强大,帮我们做好了: 输出到Ganglia 输出到控制台 输出到JMX 输出Json 详细见:dropwizard.github.io/metrics/ 依赖 添加依赖,如gradle: compile &quot;io.dropwizard.metrics:metrics-core:3.1.0&quot; compile &quot;io.dropwizard.metrics:metrics-gangl			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/pMP8pmM.html" rel="bookmark">spark之workcount</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				使用idea+maven构建spark的开发环境,遇到一点小坑,所幸最后顺利完成,使用maven管理项目还是十分必要的~~~ 1. 新建maven项目,选择scala类的项目,如图,并next 2. 填写groupID,artifactid,projectName,继续next,一路next,并填写项目名称 3. 项目生成之后,删除test中的测试类MySpec.scala,如果不删除在运行的时候可能会报测试错误 4. 在pom文件中设置scala到合适的版本 1 &lt;properties&gt; 2			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Z0KvKwM.html" rel="bookmark" class="title">算法面试题 之 最长递增子序列 LIS</a>
					<div>
						找出最长递增序列 O(NlogN)(不一定连续!) 参考 http://www.felix021.com/blog/read.php?1587%E5%8F%AF%E6%98%AF%E8%BF%9E%E ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/9MEXGy4.html" rel="bookmark" class="title">es问题汇总</a>
					<div>
						夜行侠老师视频教学:es问题汇总http://www.itjoin.org/1.如何防止索引被删除(权限控制)2.搜索的精准性控制3.解决搜索中英文数字混合4.搜索中in查询5.安装问题6.es源码内 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/n4A5mv4.html" rel="bookmark" class="title">Unity常用API</a>
					<div>
						Vector3.sqrMagnitude 长度平方					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/bMoDQk0.html" rel="bookmark" class="title">值得一看的书之《sed&amp;awk（第2版）》</a>
					<div>
						想学习高级sed和awk可以去看看,收益匪浅. --2016年11月19日看完&lt;sed&amp;awk(第2版)&gt; 下载链接:http://down.51cto.com/data/2264 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/n3ZzWd3.html" rel="bookmark" class="title">中国传统色彩研究相关书籍整理</a>
					<div>
						1.曾启雄&lt;中国失落的色彩&gt;,不是大陆出版社出版的,网上找不到这本书了,哎... 2.姜澄清&lt;中国色彩论&gt; 3.彭德&lt;中华五色&gt; 4.牛克诚&lt;色彩的中国绘画& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/n4AJKdM.html" rel="bookmark" class="title">android 开发之Toast</a>
					<div>
						今天新学了几个方法,现在分享下 Toast 的用法. Toast的用法非常简单,首先介绍一下 Toast.Toast是我在写myClock的时候遇到的,发现这是个安卓系统提供的一种非常好的提醒方式,在 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3r25Xb3.html" rel="bookmark" class="title">javascript学习一、js的初步了解</a>
					<div>
						1.javascript的简介: *javascript 是一种基于对象和事件驱动的语言,主要应用于客户端. -- 基于对象:  ** 提供了很多对象,可以直接使用. --事件驱动: ** html做 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0dxylr0.html" rel="bookmark" class="title">linux 非交互式修改用户的密码</a>
					<div>
						服务器的一些相关用户的密码过期了,我们需要修改,可是有很多机器,用常规的passwd命令,修改起来会非常的麻烦.有没有什么办法来解决一下呢,我们可以使用非交互的方式来修改用户的密码. 1 chpass ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0bnAJL0.html" rel="bookmark" class="title">android152  笔记 2</a>
					<div>
						27.谈谈UI中, Padding和Margin有什么区别? Padding 文字对边框, margin是控件对父窗体. 28. widget相对位置的完成在activity的哪个生命周期阶段实现.控 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0bY1ZvM.html" rel="bookmark" class="title">sharepoint 2013 webservice 已超过传入消息&lpar;65536&rpar;的最大消息大小配额。若要增加配额，请使用相应绑定元素上的 MaxReceivedMessageSize 属性</a>
					<div>
						在调用webservice返回数据的时候,?出现以下错误: 已超过传入消息(65536)的最大消息大小配额.若要增加配额,请使用相应绑定元素上的 MaxReceivedMessageSize 属性 这 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MoG78bM.html" rel="bookmark" class="title">Online ddl          工具之pt-online-schema-change</a>
					<div>
						MySQL ddl 的问题现状 在运维mysql数据库时,我们总会对数据表进行ddl 变更,修改添加字段或者索引,对于mysql 而已,ddl 显然是一个令所有MySQL dba 诟病的一个功能,因为 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0n51NvM.html" rel="bookmark" class="title">初见百度地图</a>
					<div>
						首先申请百度地图API KEY后,下载Android地图SDK 第一步:创建并配置工程: 将jar包,os包导入lib文件夹下 第二步:在AndroidManifest中添加开发密钥.所需权限等信息: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0jXQ2g4.html" rel="bookmark" class="title">Unity动画状态机学习</a>
					<div>
						在Unity4.x之前,动画位移,上楼梯下楼梯等动作都需要自己写模块实现,包括人物转向等等.Unity状态机的出现解决了这个问题.它有一个Apply Root Motion的选项,勾选之后即可应用根骨 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MoagWk3.html" rel="bookmark" class="title">国宝级瓷器让市民大开眼界</a>
					<div>
						元代釉里红双龙耳龙纹瓶 本报讯 (记者 夏婧 见习记者 杨晨)极具&quot;萌&quot;态的清代乾隆珐琅彩鎏金壶.高达98厘米的元代釉里红双龙耳龙纹瓶--1月20日,作为2014重庆艺术季的重头戏 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0a1WWq0.html" rel="bookmark" class="title">Edmonds-Karp算法，最大流POJ&lpar;1459&rpar;</a>
					<div>
						题目链接:http://poj.org/problem?id=1459 解题报告: 电力调度站不涉及流的产生和消耗,不用考虑,Edmonds-Karp算法,就是利用剩余网络和增广路来解决,网络中的最大 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pPpbw4.html" rel="bookmark" class="title">【探索】VS下实现虚继承的方法-2</a>
					<div>
						上篇讲到VS下实现虚继承中成员变量的二义性与数据冗余的解决方案是怎样的,今天我们来看看虚继承的成员函数会如何. 首先,虚继承会不会重写成员函数?我们看一看如下代码: #include&lt;iostr ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0ezlqp3.html" rel="bookmark" class="title">Android -- 简单广播接收与发送（1）</a>
					<div>
						1. 效果图 2. 实现代码 layout.xml &lt;Button android:id=&quot;@+id/testBtn&quot; android:layout_width=&quot; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0bKXBL3.html" rel="bookmark" class="title">centos 7安装部署docker</a>
					<div>
						1.centos 7 在windows下通过vm虚拟机安装centos 7: VMware-workstation-full-10.0.3-1895310 centos 7 2.要求 操作系统的内核版 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Myov8Y3.html" rel="bookmark" class="title">Allegro16&period;3约束设置</a>
					<div>
						差分对的约束设置 第一步,差分对的设置 差分对的设置有很多方法,下面介绍两种最常用的方法. 1． 点击菜单Logic→Assign Differential Pair... 弹出以下对话框. 点击你想 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/41eDEq4.html" rel="bookmark" class="title">VSTO 学习笔记（十三）谈谈VSTO项目的部署</a>
					<div>
						原文:VSTO 学习笔记(十三)谈谈VSTO项目的部署 一般客户计算机专业水平不高,但是有一些Office水平相当了得,尤其对Excel的操作非常熟练.因此如果能将产品的一些功能集成在Office中, ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 11 q. 0.023 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
